#! /usr/local/bin/perl -w

# This script was used to produce midiguile.c

# PLEASE DO NOT REUSE IT.  There have been much changes in midiguile.c
# and in midiwrite.h since the use of this script, so this will not
# produce anything useful.  It is merely provided for completeness and
# possibly as a starting point for writing other such scripts.

use strict;

while ( <> ) {
    if ( /^void midi_(\S+) \((.*?)\)\;$/ ) {
	my $funcname = $1;
	my $arglist = $2;
	my @arglist = split /\s*,\s*/, $arglist;
	my $v;
	my @parglist;
	foreach $v ( @arglist ) {
	    $v =~ /^(.*)\s+(\S+)$/;
	    $v = { TYPE => $1 , NAME => $2 };
	    push @parglist, $v;
	}
	if ( defined($ENV{'WHAT'}) && $ENV{'WHAT'} =~ /^names?$/i ) {
	    my $scmfuncname = $funcname;
	    $scmfuncname =~ s/\_/\-/g;
	    print "static char NAME_midi_$funcname\[\] = \"midi-$scmfuncname\";\n";
	} elsif ( defined($ENV{'WHAT'}) && $ENV{'WHAT'} =~ /^makes?$/i ) {
	    my $n = scalar @parglist;
	    print "  scm_make_gsubr (NAME_midi_$funcname, $n, 0, 0, GUILE_midi_$funcname);\n";
	} else {
	    print "static SCM\nGUILE_midi_$funcname (";
	    my $first = 1;
	    foreach $v ( @parglist ) {
		print ", " unless $first;
		print "SCM GUILE_$v->{NAME}";
		$first = 0;
	    }
	    print ")\n{\n";
	    $first = 1;
	    my $lasttype = "void";
	    foreach $v ( @parglist ) {
		my $type = $v->{TYPE};
		if ( $type eq $lasttype ) {
		    print ", $v->{NAME}";
		} else {
		    print ";\n" unless $first;
		    print "  ";
		    print "$type $v->{NAME}";
		}
		$lasttype = $type;
		$first = 0;
	    }
	    print ";\n\n";
	    print <<__EOF__;
  SCM_ASSERT (( SCM_NIMP (GUILE_m) && SCM_CAR (GUILE_m) == SMOB_midi_tag ),
	      GUILE_m, SCM_ARG1, NAME_midi_$funcname);
  m = (midi_ctx) SCM_CDR (GUILE_m);
__EOF__
	    my $i = 1;
	    foreach $v ( @parglist ) {
		next if $i == 1;
		print "  $v->{NAME} = scm_num2long (GUILE_$v->{NAME}, (char *)SCM_ARG$i,\n";
		print "\tNAME_midi_$funcname);\n";
	    } continue {
		$i++;
	    }
	    my $nl = join ", ", map { $_->{NAME} } @parglist;
	    print "  midi_$funcname ($nl);\n  return SCM_UNSPECIFIED;\n}\n\n";
	}
    }
}
